commit fd101c41d8ccb410ae186951fd966f7cacd4608e
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Tue Nov 6 11:56:26 2018 +0100

    Introduced an UML component diagram.
    Its primary purpose is to be used by super projects.

diff --git a/Target/Doc/AMiRo-BLT.svg b/Target/Doc/AMiRo-BLT.svg
new file mode 100644
index 0000000..24d7015
--- /dev/null
+++ b/Target/Doc/AMiRo-BLT.svg
@@ -0,0 +1,27 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="289px" preserveAspectRatio="none" style="width:280px;height:289px;" version="1.1" viewBox="0 0 280 289" width="280px" zoomAndPan="magnify"><defs><filter height="300%" id="fs6o5jrtan3ps" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--entity OpenBLT--><rect fill="#D3D3D3" filter="url(#fs6o5jrtan3ps)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="104" x="6" y="232"/><rect fill="#D3D3D3" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="90" y="237"/><rect fill="#D3D3D3" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="88" y="239"/><rect fill="#D3D3D3" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="88" y="243"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="64" x="21" y="264.9951">OpenBLT</text><!--entity STM32Flash--><rect fill="#D3D3D3" filter="url(#fs6o5jrtan3ps)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="124" x="145" y="232"/><rect fill="#D3D3D3" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="249" y="237"/><rect fill="#D3D3D3" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="247" y="239"/><rect fill="#D3D3D3" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="247" y="243"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="84" x="160" y="264.9951">STM32Flash</text><!--entity amiroblt.h--><ellipse cx="132" cy="37" fill="#FEFECE" filter="url(#fs6o5jrtan3ps)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="68" x="98" y="66.9951">amiroblt.h</text><!--entity AMiRoBLT--><rect fill="#FEFECE" filter="url(#fs6o5jrtan3ps)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="114" x="75" y="126"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="169" y="131"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="167" y="133"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="167" y="137"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="74" x="90" y="158.9951">AMiRo-BLT</text><!--link AMiRoBLT to OpenBLT--><path d="M116.307,172.056 C107.379,184.6032 95.9398,200.6792 85.5625,215.2636 " fill="none" id="AMiRoBLT-OpenBLT" style="stroke: #A80036; stroke-width: 1.0;"/><polygon fill="none" points="90.9696,219.7385,73.6709,231.9761,79.5625,211.6219,90.9696,219.7385" style="stroke: #A80036; stroke-width: 1.0;"/><!--link AMiRoBLT to STM32Flash--><path d="M147.906,172.056 C159.639,188.326 175.651,210.5294 188.048,227.7202 " fill="none" id="AMiRoBLT-STM32Flash" style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 7.0,7.0;"/><polygon fill="#A80036" points="191.117,231.9761,189.0974,222.3365,188.1925,227.9205,182.6085,227.0157,191.117,231.9761" style="stroke: #A80036; stroke-width: 1.0;"/><!--link amiroblt.h to AMiRoBLT--><path d="M132,46.268 C132,62.956 132,101.164 132,125.713 " fill="none" id="amiroblt.h-AMiRoBLT" style="stroke: #A80036; stroke-width: 1.0;"/><!--
+@startuml
+skinparam componentStyle uml2
+
+component OpenBLT #lightgrey
+component STM32Flash #lightgrey
+
+interface amiroblt.h
+
+component "AMiRo-BLT" as AMiRoBLT
+AMiRoBLT -down-|> OpenBLT
+AMiRoBLT .down.> STM32Flash
+AMiRoBLT -up- amiroblt.h
+
+@enduml
+
+PlantUML version 1.2018.11(Sat Sep 22 18:43:53 CEST 2018)
+(GPL source distribution)
+Java Runtime: OpenJDK Runtime Environment
+JVM: OpenJDK 64-Bit Server VM
+Java Version: 1.8.0_181-8u181-b13-1ubuntu0.16.04.1-b13
+Operating System: Linux
+OS Version: 4.15.0-38-generic
+Default Encoding: UTF-8
+Language: en
+Country: US
+--></g></svg>
\ No newline at end of file
diff --git a/Target/Doc/AMiRo-BLT.uml b/Target/Doc/AMiRo-BLT.uml
new file mode 100644
index 0000000..36ebaeb
--- /dev/null
+++ b/Target/Doc/AMiRo-BLT.uml
@@ -0,0 +1,38 @@
+/'
+AMiRo-BLT is an bootloader and toolchain designed for the Autonomous Mini
+Robot (AMiRo) platform.
+Copyright (C) 2016..2018  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+This research/work was supported by the Cluster of Excellence Cognitive
+Interaction Technology 'CITEC' (EXC 277) at Bielefeld University, which is
+funded by the German Research Foundation (DFG).
+'/
+
+@startuml
+skinparam componentStyle uml2
+
+component OpenBLT #lightgrey
+component STM32Flash #lightgrey
+
+interface amiroblt.h
+
+component "AMiRo-BLT" as AMiRoBLT
+AMiRoBLT -down-|> OpenBLT
+AMiRoBLT .down.> STM32Flash
+AMiRoBLT -up- amiroblt.h
+
+@enduml
+